<?php

/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain
 * unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 */
class Shopgate_Di extends tad_DI52_ServiceProvider
{

    /**
     * Binds and sets up implementations.
     */
    public function register()
    {
        $this->container->singleton('ShopgateConfigInterface', 'ShopgateConfigOsCommerce');
        $this->container->singleton('ShopgateOrder', 'ShopgateOrder');
        $this->container->bind('Shopgate_Models_Customers_Info', 'Shopgate_Models_Customers_Info');
        $this->container->setCtor(
            'Shopgate_Helpers_Coupon',
            'Shopgate_Helpers_Coupon',
            '@ShopgateConfigInterface',
            '@Shopgate_Models_Customers_Shopgate',
            '@Shopgate_Helpers_Products',
            '#language_id'
        );
        $this->container->setCtor('Shopgate_Helpers_Products', 'Shopgate_Helpers_Products', '#language_id');
        $this->container->setCtor(
            'Shopgate_Models_Orders_Products',
            'Shopgate_Models_Orders_Products',
            '@Shopgate_Helpers_Products',
            '@ShopgateConfigOsCommerce'
        );
        $this->container->setCtor(
            'Shopgate_Models_Orders_Products_Attributes',
            'Shopgate_Models_Orders_Products_Attributes',
            '@Shopgate_Helpers_Products',
            '@ShopgateConfigOsCommerce'
        );

        $this->rewrites();
    }

    /**
     * Binds and sets up implementations at boot time.
     */
    public function boot()
    {
    }

    /**
     * Left over for adaption rewrites
     */
    public function rewrites()
    {
        //$this->container->bind('Shopgate_Models_Customers_Native', 'Shopgate_Rewrites_Models_Customers_Native');
    }
}
