<?php

/**
 * Adding support to older versions of OsCommerce non-existent
 * methods
 */
class Shopgate_Helpers_NativeCurrencies extends currencies
{
    
    /**
     * Method didn't exist in osCommerce < 2.2 RC1
     *
     * @param     $products_price
     * @param     $products_tax
     * @param int $quantity
     *
     * @return float|string
     */
    function calculate_price($products_price, $products_tax, $quantity = 1)
    {
        if (method_exists('currencies', __FUNCTION__)) {
            return parent::calculate_price($products_price, $products_tax, $quantity);
        }
        
        global $currency;
        
        return
            tep_round(tep_add_tax($products_price, $products_tax), $this->currencies[$currency]['decimal_places'])
            * $quantity;
    }
}
