<?php
/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 */
class Shopgate_Helpers_Tax
{
    /**
     * Read the tax class title from the database by the tax value
     *
     * @param $taxValue
     *
     * @return string
     */
    public function getTaxClassByValue($taxValue)
    {
        $query          =
            "SELECT tc.tax_class_title AS title FROM " . TABLE_TAX_RATES . " AS tr
					JOIN " . TABLE_TAX_CLASS . " AS tc ON tc.tax_class_id = tr.tax_class_id
					WHERE tr.tax_rate = {$taxValue}";
        $result         = ShopgateWrapper::db_query($query);
        $taxClassResult = ShopgateWrapper::db_fetch_array($result);

        return $taxClassResult['title'];
    }

    /**
     * Read the tax class uid from the database by product id
     *
     * @param $productsId
     *
     * @return mixed
     */
    public function getProductsTaxClass($productsId)
    {
        $query          = "SELECT products_tax_class_id AS `tax_class_id` FROM "
            . TABLE_PRODUCTS . " AS p WHERE p.products_id = {$productsId}";
        $result         = ShopgateWrapper::db_query($query);
        $taxClassResult = ShopgateWrapper::db_fetch_array($result);

        return $taxClassResult['tax_class_id'];
    }
}
