<?php

/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 */

/**
 * Native class responsible for 'customers' table
 * @method int getCustomersId()
 * @method $this setCustomersId($id_int)
 * @method string getCustomersGender()
 * @method $this setCustomersGender($gender_str)
 * @method string getCustomersFirstname()
 * @method $this setCustomersFirstname($name_str)
 * @method string getCustomersLastname()
 * @method $this setCustomersLastname($surname_str)
 * @method string getCustomersDob()
 * @method $this setCustomersDob($dob_str)
 * @method string getCustomersEmailAddress()
 * @method $this setCustomersEmailAddress($address_str)
 * @method int getCustomersDefaultAddressId()
 * @method $this setCustomersDefaultAddressId($id_int)
 * @method string getCustomersTelephone()
 * @method $this setCustomersTelephone($phone_str)
 * @method string getCustomersFax()
 * @method $this setCustomersFax($fax_str)
 * @method string getCustomersPassword()
 * @method $this setCustomersPassword($password_str)
 * @method int getCustomersNewsletter()
 * @method $this setCustomersNewsletter($flag_int)
 */
class Shopgate_Models_Customers_Native extends Shopgate_Models_Abstract_Db_Collection
{
    protected $tableName = TABLE_CUSTOMERS;

    /**
     * Returns Shopgate export ready date of birth
     *
     * @return null|string
     */
    public function getShopgateReadyBirthday()
    {
        $dob = date("Y-m-d", strtotime($this->getCustomersDob()));
        if ($dob && $this->getCustomersDob() !== '0000-00-00 00:00:00') {
            return $dob;
        }

        return null;
    }
}