<?php

/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 *
 * @method int getOrdersProductsId()
 * @method $this setOrdersProductsId($id_int)
 * @method int getOrdersId()
 * @method $this setOrdersId($id_int)
 * @method int getProductsId()
 * @method $this setProductsId($id_int)
 * @method string getProductsModel()
 * @method $this setProductsModel($model_str) - something like a non-unique sku
 * @method string getProductsName()
 * @method $this setProductsName($name_str)
 * @method float getProductsPrice()
 * @method $this setProductsPrice($price_float)
 * @method float getFinalPrice()
 * @method $this setFinalPrice($price_float)
 * @method float getProductsTax()
 * @method $this setProductsTax($tax_float)
 * @method int getProductsQuantity()
 * @method $this setProductsQuantity($qty_int) - qty purchased
 */
class Shopgate_Models_Orders_Products extends Shopgate_Models_Abstract_Db_Collection
{
    protected $tableName = TABLE_ORDERS_PRODUCTS;
    /** @var Shopgate_Helpers_Products */
    protected $productHelper;
    /** @var ShopgateConfigOsCommerce */
    protected $shopgateConfig;

    /**
     * @param Shopgate_Helpers_Products $productHelper
     * @param ShopgateConfigOsCommerce  $shopgateConfig
     */
    public function __construct(
        Shopgate_Helpers_Products $productHelper,
        ShopgateConfigOsCommerce $shopgateConfig
    ) {
        $this->productHelper  = $productHelper;
        $this->shopgateConfig = $shopgateConfig;
        parent::__construct();
    }

    /**
     * Rewrite to encode saved data for
     * OsCommerce exclusively
     */
    public function beforeSave()
    {
        foreach ($this->data as &$item) {
            if (is_string($item)) {
                $item = $this->productHelper->stringFromUtf8($item, $this->shopgateConfig->getEncoding());
            }
        }
    }
}
