<?php

/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 *
 * @method int getOrdersProductsAttributesId()
 * @method $this setOrdersProductsAttributesId($id_int)
 * @method int getOrdersId()
 * @method $this setOrdersId($id_int)
 * @method int getOrdersProductsId()
 * @method $this setOrdersProductsId($id_int)
 * @method string getProductsOptions()
 * @method $this setProductsOptions($option_str)
 * @method string getProductsOptionsValues()
 * @method $this setProductsOptionsValues($value_str)
 * @method float getOptionsValuesPrice()
 * @method $this setOptionsValuesPrice($price_float)
 * @method string getPricePrefix()
 * @method $this setPricePrefix($price_str) - one symbol string, '+' or '-'
 */
class Shopgate_Models_Orders_Products_Attributes extends Shopgate_Models_Orders_Products
{
    protected $tableName = TABLE_ORDERS_PRODUCTS_ATTRIBUTES;

    /**
     * @param Shopgate_Helpers_Products $productHelper
     * @param ShopgateConfigOsCommerce  $shopgateConfig
     */
    public function __construct(
        Shopgate_Helpers_Products $productHelper,
        ShopgateConfigOsCommerce $shopgateConfig
    ) {
        $this->productHelper  = $productHelper;
        $this->shopgateConfig = $shopgateConfig;
        parent::__construct($productHelper, $shopgateConfig);
    }
}
