<?php
/**
 * Shopgate GmbH
 *
 * URHEBERRECHTSHINWEIS
 *
 * Dieses Plugin ist urheberrechtlich geschützt. Es darf ausschließlich von Kunden der Shopgate GmbH
 * zum Zwecke der eigenen Kommunikation zwischen dem IT-System des Kunden mit dem IT-System der
 * Shopgate GmbH über www.shopgate.com verwendet werden. Eine darüber hinausgehende Vervielfältigung, Verbreitung,
 * öffentliche Zugänglichmachung, Bearbeitung oder Weitergabe an Dritte ist nur mit unserer vorherigen
 * schriftlichen Zustimmung zulässig. Die Regelungen der §§ 69 d Abs. 2, 3 und 69 e UrhG bleiben hiervon unberührt.
 *
 * COPYRIGHT NOTICE
 *
 * This plugin is the subject of copyright protection. It is only for the use of Shopgate GmbH customers,
 * for the purpose of facilitating communication between the IT system of the customer and the IT system
 * of Shopgate GmbH via www.shopgate.com. Any reproduction, dissemination, public propagation, processing or
 * transfer to third parties is only permitted where we previously consented thereto in writing. The provisions
 * of paragraph 69 d, sub-paragraphs 2, 3 and paragraph 69, sub-paragraph e of the German Copyright Act shall remain unaffected.
 *
 * @author Shopgate GmbH <interfaces@shopgate.com>
 */
$shopgateMobileHeader = '';
$shopgateJsHeader     = '';

if (defined('MODULE_PAYMENT_INSTALLED')
    && (strpos(MODULE_PAYMENT_INSTALLED, 'shopgate.php') !== false)
    && !defined('SHOPGATE_PLUGIN_API_REQUEST')
) {
    include_once DIR_FS_CATALOG
        . 'ext/modules/shopgate/shopgate_library/shopgate.php';
    include_once DIR_FS_CATALOG
        . 'ext/modules/shopgate/base/shopgate_config.php';
    
    try {
        
        if (empty($_SESSION['languages_id']) && ($_SESSION['languages_id'] !== 0)) {
            $_SESSION['languages_id'] = !empty($languages_id) ? $languages_id : 0;
        }
        
        $shopgateCurrentLanguage = ShopgateWrapper::db_fetch_array(
            ShopgateWrapper::db_query(
                "SELECT * FROM `" . TABLE_LANGUAGES
                . "` WHERE languages_id = {$_SESSION['languages_id']}"
            )
        );
        
        $shopgateCurrentLanguage = (empty($shopgateCurrentLanguage) || empty($shopgateCurrentLanguage['code']))
            ? 'en'
            : $shopgateCurrentLanguage['code'];
        
        $shopgateHeaderConfig = new ShopgateConfigOsCommerce();
        $shopgateHeaderConfig->loadByLanguage($shopgateCurrentLanguage);
        
        if ($shopgateHeaderConfig->checkUseGlobalFor($shopgateCurrentLanguage)) {
            $shopgateRedirectThisLanguage = in_array(
                $shopgateCurrentLanguage,
                $shopgateHeaderConfig->getRedirectLanguages()
            );
        } else {
            $shopgateRedirectThisLanguage = true;
        }
        
        if ($shopgateRedirectThisLanguage) {
            
            // instantiate and set up redirect class
            $shopgateBuilder  = new ShopgateBuilder($shopgateHeaderConfig);
            $shopgateRedirect = $shopgateBuilder->buildRedirect();
            
            ##################
            # redirect logic #
            ##################

            if (isset($_GET['products_id']) && !empty($_GET['products_id'])) {
                $shopgateJsHeader = $shopgateRedirect->buildScriptItem($_GET['products_id']);
            } elseif (isset($HTTP_GET_VARS['products_id']) && !empty($HTTP_GET_VARS['products_id'])) {
                $shopgateJsHeader = $shopgateRedirect->buildScriptItem($HTTP_GET_VARS['products_id']);
            } elseif (!empty($current_category_id)) {
                $shopgateJsHeader = $shopgateRedirect->buildScriptCategory($current_category_id);
            } elseif (sgIsHomepage()) {
                $shopgateJsHeader = $shopgateRedirect->buildScriptShop();
            } else {
                $shopgateJsHeader = $shopgateRedirect->buildScriptDefault();
            }
        }
    } catch (ShopgateLibraryException $e) {
    }
}

/**
 * @return bool
 */
function sgIsHomepage()
{
    $scriptName = explode('/', $_SERVER['SCRIPT_NAME']);
    $scriptName = end($scriptName);
    
    if ($scriptName != 'index.php') {
        return false;
    }
    
    return true;
}
